"use strict";

var _Object$defineProperty = require("babel-runtime/core-js/object/define-property")["default"];

var _interopRequireDefault = require("babel-runtime/helpers/interop-require-default")["default"];

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.copy = copy;
exports.copySync = copySync;
exports.watch = watch;

var _cpx = require("./cpx");

var _cpx2 = _interopRequireDefault(_cpx);

exports.Cpx = _cpx2["default"];

function copy(source, outDir) {
  var options = arguments[2] === undefined ? null : arguments[2];
  var cb = arguments[3] === undefined ? null : arguments[3];

  if (typeof options === "function") {
    cb = options;
    options = null;
  }

  var cpx = new _cpx2["default"](source, outDir, options);
  if (options && options.clean) {
    cpx.clean(function (err) {
      if (err == null) {
        cpx.copy(cb);
      } else if (cb != null) {
        cb(err);
      }
    });
  } else {
    cpx.copy(cb);
  }

  return cpx;
}

function copySync(source, outDir) {
  var options = arguments[2] === undefined ? null : arguments[2];

  var cpx = new _cpx2["default"](source, outDir, options);
  if (options && options.clean) {
    cpx.cleanSync();
  }
  cpx.copySync();
}

function watch(source, outDir) {
  var options = arguments[2] === undefined ? null : arguments[2];

  var cpx = new _cpx2["default"](source, outDir, options);
  if (options && options.clean) {
    cpx.clean(function (err) {
      if (err == null) {
        cpx.watch();
      } else {
        cpx.emit("watch-error", err);
      }
    });
  } else {
    cpx.watch();
  }

  return cpx;
}