"use strict";

var _createClass = require("babel-runtime/helpers/create-class")["default"];

var _classCallCheck = require("babel-runtime/helpers/class-call-check")["default"];

var _Object$defineProperty = require("babel-runtime/core-js/object/define-property")["default"];

var _Symbol = require("babel-runtime/core-js/symbol")["default"];

_Object$defineProperty(exports, "__esModule", {
  value: true
});

var _utils = require("./utils");

var TAIL = _Symbol("tail");

function dequeue(queue, item) {
  item.action(function () {
    if (item.next) {
      setImmediate(dequeue, queue, item.next);
    } else {
      (0, _utils.assert)(queue[TAIL] === item);
      queue[TAIL] = null;
    }
  });
}

var Queue = (function () {
  function Queue() {
    _classCallCheck(this, Queue);

    this[TAIL] = null;
  }

  _createClass(Queue, [{
    key: "push",
    value: function push(action) {
      (0, _utils.assertType)(action, "action", "function");

      var item = { action: action, next: null };
      if (this[TAIL] != null) {
        this[TAIL].next = item;
        this[TAIL] = item;
      } else {
        this[TAIL] = item;
        setImmediate(dequeue, this, item);
      }
    }
  }]);

  return Queue;
})();

exports["default"] = Queue;
module.exports = exports["default"];